﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
/*

    Pattern SingleTone 
     
*/
namespace SingleTone
{
    class ConnectDB
    {
        private static ConnectDB conn;

        public static ConnectDB Instance
        {
            get
            {
                return Create();
            }
        }

        private ConnectDB()
        {
        }

        public void Connect()
        {
            Console.WriteLine("Connecting....");
        }

        public static ConnectDB Create()
        {
            if(ConnectDB.conn == null)
            {
                ConnectDB.conn = new ConnectDB();
            }

            return ConnectDB.conn;
        }
       
    }
    public class Animal
    {
        public int weight;
        public Animal(int w)
        {
            this.weight = w;
        }
    }

    public class Rabbit : Animal
    {
        public Rabbit(int w) : base (w)
        {

        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            ConnectDB.Instance.Connect();
            Animal an = new Rabbit(5);
            Console.ReadKey();
        }
    }
}
